const { PAPI } = require(`./GMLIB-LegacyRemoteCallApi/lib/BEPlaceholderAPI-JS.js`);
const Info = new JsonConfigFile("./plugins/SimpleChat/player_info.json")
Info.init("player_info", []);
const conf = new JsonConfigFile("./plugins/SimpleChat/config.json")
const MSG_API = conf.init("msg_api", {
    "{硬币}": "",
    "{护甲}": "",
    "{鸡腿}": "",
    "{Y}": "",
    "{X}": "",
    "{RT-圆}": "",
    "{LT}": "",
    "{RS}": "",
    "{LS}": "",
    "{RG}": "",
    "{LG}": "",
    "{B}": "",
    "{A}": "",
    "{0}": "",
    "{电脑图标}": "",
    "{RT-方}": "",
    "{LS衣服型}": "",
    "{开关-关}": "",
    "{开关-开}": "",
    "{潜行}": "",
    "{跳跃}": "",
    "{方向键-右}": "",
    "{方向键-下}": "",
    "{方向键-左}": "",
    "{方向键-上}": "",
    "{方向键-右下}": "",
    "{方向键-右上}": "",
    "{鼠标-中键}": "",
    "{鼠标-右键}": "",
    "{鼠标-左键}": "",
    "{右}": "",
    "{左}": "",
    "{上}": "",
    "{B-红}": "",
    "{X-黄}": "",
    "{Y-蓝}": ""
});

const COLOR_API = conf.init("color_api", {
    "{红}": "§c",
    "{黑}": "§0",
    "{深蓝}": "§1",
    "{深绿}": "§2",
    "{湖蓝}": "§3",
    "{深红}": "§4",
    "{紫}": "§5",
    "{金}": "§6",
    "{灰}": "§7",
    "{深灰}": "§8",
    "{蓝}": "§9",
    "{绿}": "§a",
    "{天蓝}": "§b",
    "{红}": "§c",
    "{粉红}": "§d",
    "{黄}": "§e",
    "{白}": "§f",
    "{硬币金}": "§g",
    "{乱码}": "§k",
    "{粗体}": "§l",
    "{斜体}": "§o",
    "{重置}": "§r",
    "{换行}": "\n"
});

const Shielding = conf.init("Shielding", [
    "傻逼",
    "尼玛币"
])

const config = conf.init("config", {
    "Enable": true,//插件启用开关
    "Chat_Bubble": true,//头顶聊天气泡开关
    "Interval": 1,//不用管
    "Prefix": "§r[§aSimpleChat§r] ",//插件指令前缀
    "Nick_length_limit": 16,//自定义昵称长度限制
    "Default_player_msg": "{player_name} {player_msg}",//普通玩家聊天格式
    "Administrator_player_msg": "[§c管理员§r] {player_name} {player_msg}",//管理员聊天格式
    "Msg_duration": 5,//聊天气泡存在世界
});

let SetName = "";
let playertitles;
const Enable = config.Enable;
const Chat_Bubble = config.Chat_Bubble;
const interval = config.Interval;
const Prefix = config.Prefix;
const Limit = config.Nick_length_limit;
const Default_Player_Msg = config.Default_player_msg;
const Administrator_Player_Msg = config.Administrator_player_msg;
const Msg_Duration = config.Msg_duration;
const Shielding_Switch = config.Shielding_Switch;
const ALL_API = { ...MSG_API, ...COLOR_API }

mc.listen("onServerStarted", function () {
    const SimpleChat = mc.newCommand("simplechat", "自定义聊天名称", PermType.Any);
    SimpleChat.setAlias('sc')
    SimpleChat.setEnum('rename', ['rename'])
    SimpleChat.setEnum('setitle', ['setitle'])
    SimpleChat.setEnum('cmd', ['gui'])
    SimpleChat.mandatory('player', ParamType.Player)
    SimpleChat.optional('string', ParamType.String)
    SimpleChat.mandatory('rename', ParamType.Enum, 'rename', 1)
    SimpleChat.mandatory('setitle', ParamType.Enum, 'setitle', 1)
    SimpleChat.mandatory('cmd', ParamType.Enum, 'cmd', 1)
    SimpleChat.overload(['rename', 'string'])
    SimpleChat.overload(['setitle', 'player', 'string'])
    SimpleChat.overload(['cmd'])
    SimpleChat.setCallback(function (_cmd, ori, out, res) {
        if (Enable == 0) {
            if (!ori.player) return out.error("插件已关闭");
            if (ori.player) return ori.player.tell(Prefix + "插件已关闭");
            return;
        } else if (Enable == 1) {
            if (!ori.player) return out.error("控制台无法使用此命令");
            if (ori.player) {
                if (res.cmd == "gui") {
                    GUI(ori.player);
                }
                if (res.rename == "rename") {
                    if (res.string != undefined) {
                        if (res.string.length <= Limit) {
                            SetName = setChatName(ori.player.realName, false, res.string);
                            ori.player.tell(Prefix + "你已将昵称设为: " + SetName);
                        } else if (res.string.length > Limit) {
                            ori.player.tell(Prefix + "昵称长度不能超过" + Limit + "个字符!");
                            return;
                        }
                        return;
                    } else if (res.string == undefined) {
                        SetName = setChatName(ori.player.realName, false, ori.player.realName);
                        ori.player.tell(Prefix + "你的名称已重置!");
                        return;
                    }
                }
                if (res.setitle == "setitle") {
                    if (!ori.player.isOP()) {
                        ori.player.tell(Prefix + "只有管理员才能使用此命令!");
                        return;
                    } else {
                        if (res.player && res.player[0] && res.player[0].realName) {
                            SetName = setChatName(res.player[0].realName, false);
                            playertitles = setChatName(res.player[0].realName, true, SetName, res.string);
                            ori.player.tell(Prefix + "你已将§a " + res.player[0].realName + " §r的称号设为: " + playertitles);
                        } else { ori.player.tell(Prefix + "无法获取玩家的真实名字，无法设置称号。"); }
                    }
                }
            }
        }
    })
    SimpleChat.setup();
});

mc.listen("onChat", function (player, msg) {
    let setmsg = JSON.stringify(msg)
    let playermsg = JSON.parse(setmsg);
    SetName = setChatName(player.realName, false)
    playertitles = setChatName(player.realName, true);
    setName(player.realName, Msg_Duration + 1, playermsg)
    const msgTemplate = player.isOP() ? Administrator_Player_Msg : Default_Player_Msg;
    if (playertitles == undefined) { playertitles = "" } else { playertitles = `[${playertitles}§r] ` }
    let strObj = JSON.stringify(msgTemplate)
        .replace(/\{player_name}/g, SetName)
        .replace(/\{player_msg}/g, playermsg)
        .replace(/\{player_titles}/g, playertitles)
    for (const key in ALL_API) {
        strObj = strObj.replace(new RegExp(escapeRegExp(key), 'g'), ALL_API[key]);
    }
    let Obj = JSON.parse(strObj);
    let PAPIObj = PAPI.translateString(Obj, player);
    PAPIObj = ReplaceString(Obj, player)
    for (const i in Shielding) {
        if (Shielding_Switch == 1 && PAPIObj.includes(Shielding[i])) return player.tell(Prefix + "请不要说藏话") + logger.log(player.realName + " 说藏话了" + mc.broadcast(Prefix + player.realName + " 说藏话了"));
    }
    mc.broadcast(PAPIObj)
    log(player.realName + PAPIObj)
    return false;
})


setInterval(() => {
    let pls = mc.getOnlinePlayers();
    if (pls.length != 0 && Chat_Bubble == 1) {
        pls.forEach((pl, i) => {
            if (pl.realName != SetName[i]) { SetName = setChatName(pl.realName, false) }
            playertitles = setChatName(pl.realName, true)
            for (const key in ALL_API) {
                SetName = SetName.replace(new RegExp(escapeRegExp(key), 'g'), ALL_API[key]);
            }
            let plname = PAPI.translateString(SetName, pl);
            let playermsg = Info.get("player_info");
            playermsg.filter(player => player.name == pl.realName).forEach(player => {
                let msg = player.msg;
                msg = ReplaceString(msg, pl)
                let strObj = JSON.stringify(msg)
                strObj = strObj.replace(/"/g, '');
                if (playertitles == undefined) { playertitles = "" } else { playertitles = `[${playertitles}§r] ` }
                if (player.time) { pl.rename(`${strObj}\n${playertitles} ${plname}`); } else { pl.rename(playertitles + plname); }
            });
        });
    }
}, interval * 1000);

function GUI(player) {
    var fm = mc.newSimpleForm();
    fm.setTitle('SimpleChat')
    if (player.isOP()) fm.addButton("设置称号", "textures/ui/pencil_edit_icon.png")
    fm.addButton("修改昵称", "textures/ui/settings_glyph_color_2x.png")
    fm.addButton("重置昵称", "textures/ui/refresh_hover.png")
    player.sendForm(fm,
        function (pla, id) {
            if (id == 0) {
                if (player.isOP()) { setTitle_GUI(pla) } else { pla.tell(Prefix + "你没有权限使用") }
            } else if (id == 1) {
                setName_GUI(pla)
            } else if (id == 2) {
                setChatName(player.realName, false, pla.realName);
                pla.rename(pla.realName);
                pla.tell(Prefix + "你的昵称已重置");
            }
        })
}

function setTitle_GUI(player) {
    let players = []
    let playersName = []
    let pls = mc.getOnlinePlayers();
    for (let i in pls) {
        playersName.push(pls[i].realName)
        players.push(pls[i])
    }
    var fm = mc.newCustomForm();
    fm.setTitle('SimpleChat-setitle')
    fm.addDropdown('选择玩家', playersName)
    fm.addInput('输入新称号', "例如: 小男娘 小萝莉")
    player.sendForm(fm,
        function (pla, id) {
            if (id != null) {
                if (id[2] == "") {
                    pla.tell(Prefix + "称号不能为空")
                } else {
                    SetName = setChatName(players[id[0]].realName, false)
                    setChatName(players[id[0]].realName, true, SetName, id[1])
                    mc.broadcast(Prefix + "恭喜玩家§a " + players[id[0]].realName + " §r获得新称号 " + id[1])
                }
            }
        })
}

function setName_GUI(player) {
    SetName = setChatName(player.realName, false);
    var fm = mc.newCustomForm();
    fm.setTitle('SimpleChat-setName')
    fm.addLabel('你现在的昵称是' + SetName + "§r")
    fm.addInput('输入新的昵称', "例如: 阿巴阿巴 abab")
    player.sendForm(fm,
        function (pla, id) {
            if (id != null) {
                if (id[1] != "") {
                    setChatName(player.realName, false, id[1]);
                    pla.rename(id[1]);
                    pla.tell(Prefix + "你的昵称已修改为: " + id[1]);
                } else {
                    pla.tell(Prefix + "输入不能为空");
                }
            }
        })
}

function ReplaceString(String, Player) {
    let Return = String
    let MatchList = String.match(/(?<=\{)(\w+)(?=\})/g)
    for (var i in MatchList) {
        var PathList = MatchList[i].split('_')
        try {
            var Result = GetPlayer(Player, PathList)
        } catch (e) {
            var Result = MatchList[i]
        }
        let reg = new RegExp('{' + MatchList[i] + '}', 'g')
        Return = Return.replace(reg, Result)
    }
    return Return
}

function GetPlayer(player, Path) {
    let object = player
    for (var i = 0; i < Path.length; i++) {
        object = object[Path[i]]
    }
    return object
}

function escapeRegExp(string) {
    return string.replace(/[.*+?^${}()|[\]\\]/g, '\\$&');
}

function setTitle(name, title) {
    const LIST = Info.get("player_info");
    for (let i in LIST) {
        if (LIST[i].hasOwnProperty(name)) {
            LIST[i][name].title = title;
            break;
        }
    }
    Info.set("player_info", LIST);
}

function setChatName(name, getTitle = false, nick, title, time = 0) {
    const playerNick = Info.get("player_info") || [];
    const player = playerNick.find(p => p.name === name) || { name, nick: name, time, msg: "", title: title };
    if (!player.nick) player.nick = name;
    if (nick) player.nick = nick;
    if (title) player.title = title;
    if (!playerNick.includes(player)) playerNick.push(player);
    playerNick.forEach(player => {
        if (player.name === name && player.time > 0) player.time--;
    });
    Info.set("player_info", playerNick);
    return getTitle ? player.title : player.nick;
}

function setName(name, time, msg) {
    const playerNick = Info.get("player_info") || [];
    const player = playerNick.find(p => p.name === name);
    if (player) {
        if (player.time < time) {
            player.time = time;
            player.msg = msg;
        }
        if (player.time > 0 && player.name === name) player.time--;
    }
    Info.set("player_info", playerNick);
    return player ? player.nick : null;
}

logger.log(`正在加载SimpleChat...

§a███████╗§c██╗§e███╗   ███╗§3██████╗ §2██╗     §5███████╗§b ██████╗§a██╗  ██╗§e █████╗ §c████████╗
§a██╔════╝§c██║§e████╗ ████║§3██╔══██╗§2██║     §5██╔════╝§b██╔════╝§a██║  ██║§e██╔══██╗§c╚══██╔══╝
§a███████╗§c██║§e██╔████╔██║§3██████╔╝§2██║     §5█████╗  §b██║     §a███████║§e███████║§c   ██║   
§a╚════██║§c██║§e██║╚██╔╝██║§3██╔═══╝ §2██║     §5██╔══╝  §b██║     §a██╔══██║§e██╔══██║§c   ██║   
§a███████║§c██║§e██║ ╚═╝ ██║§3██║     §2███████╗§5███████╗§b╚██████╗§a██║  ██║§e██║  ██║§c   ██║   
§a╚══════╝§c╚═╝§e╚═╝     ╚═╝§3╚═╝     §2╚══════╝§5╚══════╝§b ╚═════╝§a╚═╝  ╚═╝§e╚═╝  ╚═╝§c   ╚═╝   
`);

mc.listen("onServerStarted", function () {
    logger.log("加载成功! 感谢使用!")
})